#include <iostream>
using namespace std;
const int MAXN=1e6+10;
long long cur[MAXN], pr[MAXN][2];
int main () {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    int n;
    long long p, m, ind;
    cin >> n;
    for (int i=1;i<=n;i++) {
        cin >> p >> m;
        if (m>0) {
            pr[i][0]=p;
            pr[i][1]=m;
            cur[i]=cur[p]+m;
        } else {
            cur[i]=cur[p]-pr[p][1];
            ind=pr[p][0];
            pr[i][0]=pr[ind][0];
            pr[i][1]=pr[ind][1];
        }
    }
    long long ans=0;
    for (int i=1;i<=n;i++) ans+=cur[i];
    cout << ans << endl;
    return 0;
}
